;;; DynaDim.lsp
;;;
;;;
;;; Boilerplate:
;;;
;;; This is sort of a front end for "Dim Dia" and "Dim Rad" commands.
;;;
;;; It works stand alone or transparently within the "DIM" command.
;;;
;;; If you have crammed up drawings give it a try, once you get used 
;;; to it it'll become part of your daily work.
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774
;;;
;;;

;;; error trap
(defun dynerror (msg)
(if (member msg '("console break" "Function cancelled" "Cancel"))
 (princ "\n*User cancelled*")
 (princ (strcat "\nError: " msg))
 );if
(if ervlst
 (progn
  (grvecs ervlst)
  (setq drg T
        ervlst nil
   );setq
  );progn
 );if
(dynreset)
(princ)
 );defun

;;; reset function
(defun dynreset ()
 (setvar "dimtix" dtx)
 (setvar "blipmode" blip)
 (setvar "cmdecho" eco)
 (setq diad nil
       radd nil
       *error* acaderr
  );setq
);defun

;;;Main function
 (defun ddrag ( / ref1 1stpk corpk ntsel ntnam cnpt nept 
                  blip dimt fuz
                  anga angb dragnt angc angd ange dtol dlim tlo thi dtfac 
                  dalt daltd suf sufalt unt dlimht dimstr dimbx bx12ep dimbxx 
                  dimbxy tolht bx1x bx1y thistr tlostr thibx bx22ep bx2x bx2y 
                  tlobx bx32ep bx3x bx3y lhistr llostr dlimht hibx hibx2ep 
                  hibxx hibxy lobx lobx2ep lobxx lobxy dimang ndpt rad ntyp 
                  ref2 dtx dmasz dragpt ustr txbx bx 2ep txtht promp id ldp 
                  ldt ldte ldtel bx1 bx2 bx3 bx4 erldp erldt cll clp1 clp2 
                  clp3 clp4 asz1 asz2 vlst ervlst drg)

     (setq refal T
           cmdstr (getvar "cmdnames"))
     (if (/= cmdstr "DIM")
          (command "dim1")
      );if
    (while refal
     (setq acaderr *error*
           *error* dynerror
           ref1 T
           eco (getvar "cmdecho")
           fuz (* 0.001 (getvar "dimscale"))
           cll  (* (/ (getvar "dimtxt") 2)(* (getvar "dimscale") 1.3))
           dtx (getvar "dimtix")
           dmasz (* (getvar "dimscale")(getvar "dimasz"))
      );setq
     (setvar "cmdecho" 0)
     (while ref1
         (while (not 1stpk)
         (setq 1stpk (cadr (nentsel "\nSelect Circle or Arc :")))
         (if (not 1stpk)(progn (princ "\nNothing selected! ")(princ)))
         );while
         (setq corpk (osnap 1stpk "nea"))
          (if corpk
                   (progn
                         (setq cnpt (osnap corpk "cen")
                               nept (osnap corpk "nea")
                               ndpt (osnap corpk "endp")
                               clp1 (polar cnpt 0.0 cll)
                               clp2 (polar cnpt pi cll)
                               clp3 (polar cnpt (/ pi 2) cll)
                               clp4 (polar cnpt (* pi 1.5) cll)
                          );setq
                    );progn
          );if
          (cond
               ((and cnpt (not ndpt))(setq ntyp "CIRCLE"))
               ((and cnpt ndpt)(setq ntyp "ARC"))
          );cond
          (cond
               ((and ntyp diad (not radd))(setq ntyp "CIRCLE"))
               ((and ntyp radd (not diad))(setq ntyp "ARC"))
          );cond
          (if (or (= ntyp "CIRCLE")(= ntyp "ARC"))
              (setq ref1 nil)
              (progn (princ "\nObject is not a Circle or Arc")
                     (setq 1stpk nil)
                     (princ)
               );progn
          );if
     (princ)
     
);while ref1
     (cond
          ((= ntyp "CIRCLE")(progn (setq rad (distance cnpt nept)
                                         dimt (* rad 2)
                                         ntsel (nentselp corpk)
                                         ntnam (car ntsel)
                                         promp (strcat "\nDimension text  <" 
                                                       (rtos dimt) ">: ")
                                         ref2 T
                                         ustr (getstring T promp)
                                         blip (getvar "blipmode"))
                                   (setvar "blipmode" 0))
          );circle
          ((= ntyp "ARC")(progn (setq rad (distance cnpt nept)
                                      dimt rad
                                      ntsel (nentselp corpk)
                                      ntnam (car ntsel)
                                      promp (strcat "\nDimension text <R" 
                                                    (rtos dimt) ">:")
                                      ref2 T
                                     ustr (getstring T promp)
                                     blip (getvar "blipmode"))
                                (setvar "blipmode" 0))
          );arc
     );cond
          (setq txtht (* (getvar "dimtxt")(getvar "dimscale"))
                ldtel txtht
                anga (cvunit 15 "degree" "radian")
                angb (cvunit 165 "degree" "radian")
                angc (cvunit 195 "degree" "radian")
                angd (cvunit 345 "degree" "radian")
                ange (cvunit 360 "degree" "radian")
                dtol (getvar "dimtol")        ;pres of tol
                dlim (getvar "dimlim")        ;lim type of tol
                tlo (getvar "dimtm")          ;lo side
                thi (getvar "dimtp")          ;hi side
                dtfac (getvar "dimtfac")      ;height fact of tol
                dalt (getvar "dimalt")        ;alt dim
                daltd (getvar "dimaltd")      ;dec places of alt posting
                suf (getvar "dimpost")        ;dim suffix
                sufalt (getvar "dimapost")    ;alt dim suffix
                prec (getvar "luprec")        ;precision of main string
                unt (getvar "lunits")         ;linear units type
                dlimht (* txtht dtfac)        ;height of dimlim text
                tolht dlimht                  ;height of tol text
          );setq  
      (cond
          ((> (strlen ustr) 0)
           (setq dimstr ustr
                 dimbx (textbox (list (cons 40 txtht)(cons 1 dimstr)))
                 bx12ep (cadr dimbx)
                 dimbxx (car bx12ep)
                 dimbxy (cadr bx12ep)
            );setq
           );cond_1
          ((and (= dtol 0)(= dlim 0)(= dalt 0))
           (setq dimstr (strcat "R" (rtos dimt unt prec) suf) 
                 dimbx (textbox (list (cons 40 txtht)(cons 1 dimstr)))
                 bx12ep (cadr dimbx)
                 dimbxx (car bx12ep)
                 dimbxy (cadr bx12ep)
            );setq
           );cond_2
          ((and (= dtol 0)(= dlim 0)(= dalt 1))
           (setq dimstr (strcat "R" (rtos dimt unt prec) suf " ["(rtos 
                                 (* dimt 25.4) 2 daltd)"]" sufalt)
                 dimbx (textbox (list (cons 40 txtht)(cons 1 dimstr)))
                 bx12ep (cadr dimbx)
                 dimbxx (car bx12ep)
                 dimbxy (cadr bx12ep)
            );setq
           );cond_3
          ((and (= dtol 1)(= dalt 0))
           (setq dimstr (strcat "R" (rtos dimt unt prec) suf)
                 dimbx (textbox (list (cons 40 txtht)(cons 1 dimstr)))
                 bx12ep (cadr dimbx)
                 bx1x (car bx12ep)
                 bx1y (cadr bx12ep)
                 thistr (strcat "+"(rtos thi unt prec))
                 tlostr (strcat "+"(rtos tlo unt prec))
                 thibx (textbox (list (cons 40 tolht)(cons 1 thistr)))
                 bx22ep (cadr thibx)
                 bx2x (car bx22ep)
                 bx2y (cadr bx22ep)
                 tlobx (textbox (list (cons 40 tolht)(cons 1 tlostr)))
                 bx32ep (cadr tlobx)
                 bx3x (car bx32ep)
                 bx3y (cadr bx32ep)
                 dimbxx (+ bx1x bx2x)
                 dimbxy (+ bx2y bx3y (* tolht 0.7))
            );setq
           );cond_4
          ((and (= dtol 1)(= dalt 1))
           (setq dimstr (strcat "R" (rtos dimt unt prec) suf " ["(rtos (* dimt 25.4) 2 daltd) sufalt "]")
                 thistr (strcat (rtos thi unt prec) suf " ["(rtos (* thi 25.4) 2 daltd) sufalt "]")
                 tlostr (strcat (rtos tlo unt prec) suf " ["(rtos (* tlo 25.4) 2 daltd) sufalt "]")
                 dimbx (textbox (list (cons 40 txtht)(cons 1 dimstr)))
                 bx12ep (cadr dimbx)
                 bx1x (car bx12ep)
                 bx1y (cadr bx12ep)
                 thibx (textbox (list (cons 40 tolht)(cons 1 thistr)))
                 bx22ep (cadr thibx)
                 bx2x (car bx22ep)
                 bx2y (cadr bx22ep)
                 tlobx (textbox (list (cons 40 tolht)(cons 1 tlostr)))
                 bx32ep (cadr tlobx)
                 bx3x (car bx32ep)
                 bx3y (cadr bx32ep)
                 dimbxx (+ bx1x bx2x)
                 dimbxy (+ bx2y bx3y (* tolht 0.7))
            );setq
           );cond_5
          ((and (= dlim 1)(= dalt 0))
           (setq lhistr (strcat "R " (rtos (+ dimt thi)) suf)
                 llostr (strcat "R " (rtos (- dimt tlo)) suf)
                 dlimht (* txtht dtfac)
                 hibx (textbox (list (cons 40 dlimht)(cons 1 lhistr)))
                 hibx2ep (cadr hibx)
                 hibxx (car hibx2ep)
                 hibxy (cadr hibx2ep)
                 lobx (textbox (list (cons 40 dlimht)(cons 1 llostr)))
                 lobx2ep (cadr lobx)
                 lobxx (car lobx2ep)
                 lobxy (cadr lobx2ep)
                 dimbxx hibxx
                 dimbxy (+ hibxy lobxy (* tolht 0.7))
            );setq
           );cond_6
          ((and (= dlim 1)(= dalt 1))
           (setq lhistr (strcat "R" (rtos (+ dimt thi) unt prec) suf " [" (rtos 
                                    (* 25.4 (+ dimt thi)) 2 daltd) sufalt "]")
                 llostr (strcat "R" (rtos (+ dimt tlo) unt prec) suf " [" (rtos 
                                    (* 25.4 (+ dimt tlo)) 2 daltd) sufalt "]")
                 hibx (textbox (list (cons 40 dlimht)(cons 1 lhistr)))
                 hibx2ep (cadr hibx)
                 hibxx (car hibx2ep)
                 hibxy (cadr hibx2ep)
                 lobx (textbox (list (cons 40 dlimht)(cons 1 llostr)))
                 lobx2ep (cadr lobx)
                 lobxx (car lobx2ep)
                 lobxy (cadr lobx2ep)
                 dimbxx hibxx
                 dimbxy (+ hibxy lobxy (* tolht 0.7))
            );setq
           );cond_7
       );cond
          (prompt "Pick text location:")
          (while ref2
          (setq dragpt (grread T 4 0)
                id (car dragpt)
                ldt (cadr dragpt)
           );setq
          (cond
               ((and (= id 5) (or (= ntyp "CIRCLE")(= ntyp "ARC")))
               (progn (setq ldp (osnap (polar cnpt (angle cnpt ldt) rad) "nea"))
                           (if (not ldp)(setq ldp (osnap (polar cnpt (angle cnpt ldt)(- rad)) "nea")))
                           (if ldp (progn (setq dragnt (car (nentselp ldp))
                                                dimang (angle ldp ldt)
                                                asz1 (polar ldp (- dimang 0.17) dmasz) 
                                                asz2 (polar ldp (+ dimang 0.17) dmasz)
                                            );setq
                           (if (or (and (<= dimang anga)
                                        (> dimang 0.0))
                                   (and (>= dimang angb)
                                        (<= dimang angc))
                                   (and (>= dimang angd)
                                        (<= dimang ange))
                                );or
                               (setq ldtel (* txtht 0.666))(setq ldtel (* txtht 1.666))
                            );if
                           (if (< (distance ldp ldt)(* dmasz 2))
                                (setq ldt (polar ldp (angle ldp ldt)(* dmasz 2)))
                            );if
                           (if (and (> dimang (* pi 0.5))(<= dimang(* pi 1.5)))
                               (progn (setq ldte (polar ldt pi ldtel)
                                             bx1 (polar ldte (* pi 0.5)(/ dimbxy 2))
                                             bx2 (polar bx1 pi dimbxx)
                                             bx3 (polar bx2 (* pi 1.5) dimbxy)
                                             bx4 (polar bx3 0.0 dimbxx))
                                );progn
                            );if
                           (if (or (and (<= dimang (* pi 0.5))
                                        (> dimang 0.0))
                                   (and (>= dimang(* pi 1.5))
                                        (<= dimang(* pi 2)))
                               );or
                               (progn (setq ldte (polar ldt 0.0 ldtel)
                                             bx1 (polar ldte (* pi 0.5)(/ dimbxy 2))
                                             bx2 (polar bx1 0.0 dimbxx)
                                             bx3 (polar bx2 (* pi 1.5) dimbxy)
                                             bx4 (polar bx3 pi dimbxx))
                                );progn
                            );if
                                    );progn
                            );if
                           (if (and ldp 
                                    (eq ntnam dragnt)
                                );and
                                 (progn (setq vlst (list 256 ldp asz1 asz1 asz2 asz2 ldp 
                                        ldp ldt ldt ldte bx1 bx2 bx2 bx3 
                                        bx3 bx4 bx4 bx1 clp1 clp2 clp3 clp4)
                                         );setq
                                        (if (not (equal vlst ervlst fuz))
                                             (progn (grvecs ervlst)
                                                    (setq drg T
                                                          ervlst nil
                                                     );setq
                                              );progn
                                         );if
                                        (if (and vlst drg)
                                             (progn (grvecs vlst)
                                                    (setq drg nil
                                                          ervlst vlst
                                                          vlst nil
                                                     );setq
                                              );progn
                                         );if
                                  );progn
                );if
                );progn
               );id5
               ((= id 3) (progn (setq ldp (osnap (polar cnpt (angle cnpt ldt) rad) "nea"))
                                (if (not ldp)(setq ldp (osnap (polar cnpt (angle cnpt ldt)(- rad)) "nea")))
                                (cond ((= ntyp "CIRCLE")(progn 
                                                              (if (and (< (distance cnpt ldt) rad)
                                                                       (> (* rad 0.6)dimbxx)) 
                                                              (setvar "dimtix" 1)(setvar "dimtix" 0))
                                                              (grvecs ervlst)
                                                              (setq drg T
                                                                    ervlst nil
                                                               );setq
                                                              (command "dia" ldp ustr ldt)))
                                      ((= ntyp "ARC")(progn (setvar "dimtix" 0)
                                                            (grvecs ervlst)
                                                            (setq drg T
                                                                  ervlst nil
                                                             );setq
                                                            (command "rad" ldp ustr ldt)))
                                );cond
                                (dynreset)
                                (setq ref2 nil)
                         );progn
               );id3
               ((= id 6)
                (setq id 5)
                );cond id6
           );cond
           );while ref2
      (setq refal nil)
     );while refal
     (princ)
  );defun 

     ;;;Driver seat 
 (defun C:DD ()
   (ddrag)
  );defun

 (defun C:DDD (/ diad)
   (setq diad T)
   (ddrag)
  );defun

 (defun C:DDR (/ radd)
   (setq radd T)
   (ddrag)
  );defun

    (princ "\n          Dynadim Loaded            ")
    (princ "\n  DD (auto) - DDD (dia) - DDR (rad) ")
    (princ)
