;;; EzDim.lsp
;;;
;;; Boilerplate:
;;;
;;; This is sort of a front end for "Dim Hor", "Dim Ver" and 
;;; "Dim Align" commands. It resembles a lot to part of R13's
;;; dim command
;;;
;;; It works stand alone or transparently within the "DIM" command.
;;;
;;; If you have crammed up drawings give it a try, once you get used 
;;; to it it'll become part of your daily work.
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774

;;; error trap ;;;
(defun ezerror (msg)
(if (member msg '("console break" "Function cancelled" "Cancel"))
 (princ "\n*User cancelled*")
 (princ (strcat "\nError: " msg))
 );if
(if ervlst (erdrag))
(ezreset)
(princ)
);defun

;;; reset function ;;;
(defun ezreset ()
 (setvar "cmdecho" eco)
 (setvar "osmode" osm)
 (setq *error* acaderr)
);defun

;;; main function ;;;
(defun ezdim ( / Qkwd1 Qkwd2 exe exo asz osm eco px1 cmdstr olderr err
                 px2 dst1 px1x px1y acaderr pd1 pd2 ptmp px1z px2x px2y 
                 px2z p1 p2 p3 p4 ptm ptmx ptmy pal1 pal2 pal3 pal4 
                 refdst angp1 angp2 angp3 angp4 dzro id idr ptx angc angal 
                 angal1 angal2 angptx angpx1 angpx2 angpx3 angpx4 anga angp 
                 angm vlst ervlst erptx mode promp drg pho1 pho2 pho1x 
                 pho1y pho2x pho2y pve1 pve2 pve1x pve1y pve2x pve2y ptxx 
                 ptxy dstptx)
 (setq acaderr *error*
       *error* ezerror
       exo (* (getvar "dimscale")(getvar "dimexo"))
       exe (* (getvar "dimscale")(getvar "dimexe"))
       asz (* (getvar "dimscale")(getvar "dimasz"))
       osm (getvar "osmode")
       eco (getvar "cmdecho")
       cmdstr (getvar "cmdnames")
);setq
(setq EZkwd1 T)
(if (/= cmdstr "DIM")
     (command "dim1")                     
 );if
 (while EZkwd1
    (while (not px1)
           (setq px1 (getpoint "\nSelect first point: "))
     );while
    (while (not (setq px2 (getpoint px1 "\nSelect second point: ")))
     );while
  (setvar "osmode" 0)
  (setvar "cmdecho" 0)
  (setq dst1 (distance px1 px2)
        px1x (car px1)
        px1y (cadr px1)
        px1z (caddr px1)
        px2x (car px2)
        px2y (cadr px2)
        px2z (caddr px2)
 );setq
  (if (< px1x px2x)
        (setq pal1 px2
              pal2 px1
              pho1 px2
              pho2 px1
       );setq
        (setq pal1 px1
              pal2 px2
              pho1 px1
              pho2 px2
       );setq
 );if
  (if (> px1y px2y)
        (setq pve1 px2
              pve2 px1
       );setq
        (setq pve1 px1
              pve2 px2
       );setq
 );if
  (setq anga (angle pal1 pal2)
        angp (+ anga (* pi 0.5))
        angm (- anga (* pi 0.5))
        refdst (/ dst1 2)
        ptm (polar pal1 anga refdst)
        ptmx (car ptm)
        ptmy (cadr ptm)
        pho1x (car pho1)
        pho1y (cadr pho1)
        pho2x (car pho2)
        pho2y (cadr pho2)
        pve1x (car pve1)
        pve1y (cadr pve1)
        pve2x (car pve2)
        pve2y (cadr pve2)
        p1 (list (min px1x px2x)(min px1y px2y))
        p2 (list (max px1x px2x)(min px1y px2y))
        p3 (list (max px1x px2x)(max px1y px2y))
        p4 (list (min px1x px2x)(max px1y px2y))
        angp1 (* pi 1.25)
        angp2 (* pi 1.75)
        angp3 (* pi 0.25)
        angp4 (* pi 0.75)
 );setq
 (prompt "\nHorizontal, Vertical or Aligned? ")
 (terpri)
 (setq EZkwd2 T)
   (while EZkwd2
    (setq dzro (grread T)
          id (car dzro)
          idr (cadr dzro)
     );setq
  (if (or (= id 3)(= id 5))
    (setq ptx (cadr dzro)
          ptxx (car ptx)
          ptxy (cadr ptx)
          angal (angle ptm ptx)
          angal1 (angle pal1 ptx)
          angal2 (angle pal2 ptx)
          angptx (angle pal1 ptx)
          dstptx (distance pal1 ptx)
          angsin (- (max anga angptx)(min anga angptx))
          ht (* (sin angsin) dstptx)
          angpx1 (angle p1 ptx)
          angpx2 (angle p2 ptx)
          angpx3 (angle p3 ptx)
          angpx4 (angle p4 ptx)
     );setq
   );if
   (cond
    ((= id 6)
     (setq id 5)
     );cond id6
    ((and (= id 5)
          (/= px1x px2x)
          (/= px1y px2y)
          (or (and (> angptx anga)
                   (< angal1 angp)
                   (> angal2 angp)
               );and
              (and (< angptx anga)
                   (> angal1 angm)
                   (< angal2 angm)
               );and
           );or
      );and
   (progn (if (> angptx anga)
              (setq dp1 (polar pal1 angp exo)
                    dp2 (polar pal2 angp exo)
                    dp3 (polar pal1 angp (+ ht exe))
                    dp4 (polar pal2 angp (+ ht exe))
                    apt1 (polar dp1 angp (- ht exo))
                    at1 (polar apt1 (- anga 0.17) asz)
                    at2 (polar apt1 (+ anga 0.17) asz)
                    apt2 (polar dp2 angp (- ht exo))
                    at3 (polar apt2 (- anga (+ pi 0.17)) asz)
                    at4 (polar apt2 (+ anga (+ pi 0.17)) asz)
               );setq
           );if
          (if (< angptx anga)
              (setq dp1 (polar pal1 angm exo)
                    dp2 (polar pal2 angm exo)
                    dp3 (polar pal1 angm (+ ht exe))
                    dp4 (polar pal2 angm (+ ht exe))
                    apt1 (polar dp1 angm (- ht exo))
                    at1 (polar apt1 (- anga 0.17) asz)
                    at2 (polar apt1 (+ anga 0.17) asz)
                    apt2 (polar dp2 angm (- ht exo))
                    at3 (polar apt2 (- anga (+ pi 0.17)) asz)
                    at4 (polar apt2 (+ anga (+ pi 0.17)) asz)
               );setq
           );if
          (setq vlst (list 256 dp1 dp3 dp2 dp4 apt1 apt2 at1 apt1 apt1 at2
                                at2 at1 at3 apt2 apt2 at4 at4 at3)
                mode "align"
                dmod "align"
           );setq
          (if (/= promp "Al")
           (progn (setq promp "Al")
                  (prompt "\nAligned? ")
                  (terpri)
            );progn
           );if
  (dodrag)   
    );progn
     );cond align
    ((and (= id 5)
          (or (= px1y px2y)
              (and
               (= dmode "hor")
               (> ptxx (min px1x px2x))
               (< ptxx (max px1x px2x))
               (> ptxy (min px1y px2y))
               (< ptxy (max px1y px2y))
               );and
              (and
               (< ptxy (min px1y px2y))
               (>= angpx1 angp1)
               (<= angpx1 (* pi 2.0))
               (<= angpx2 angp2)
               (>= angpx2 pi)
               );and
              (and
               (> ptxy (max px1y px2y))
               (>= angpx3 angp3)
               (<= angpx3 pi)
               (<= angpx4 angp4)
               (>= angpx4 0.0)
               );and
           );or
    );and
     (progn
      (setq apt1 (list pho1x ptxy)
            apt2 (list pho2x ptxy)
            dp1 (polar pho1 (angle pho1 apt1) exe)
            dp2 (polar pho2 (angle pho2 apt2) exe)
            dp3 (polar apt1 (angle pho1 apt1) exo)
            dp4 (polar apt2 (angle pho2 apt2) exo)
            at1 (polar apt1 (- (angle apt1 apt2) 0.17) asz)
            at2 (polar apt1 (+ (angle apt1 apt2) 0.17) asz)
            at3 (polar apt2 (- (angle apt2 apt1) 0.17) asz)
            at4 (polar apt2 (+ (angle apt2 apt1) 0.17) asz)
            vlst (list 256 dp1 dp3 dp2 dp4 apt1 apt2 at1 apt1 apt1 
                            at2 at2 at1 at3 apt2 apt2 at4 at4 at3)
            mode "hor"
            dmode "hor"
       );setq
          (if (/= promp "Hor")
           (progn (setq promp "Hor")
                  (prompt "\nHorizontal? ")
                  (terpri)
            );progn
           );if
      (dodrag)
      );progn
     );cond horizontal
    ((and (= id 5)
          (or (= px1x px2x)
              (and
               (= dmode "ver")
               (> ptxx (min px1x px2x))
               (< ptxx (max (car pal1)(car pal2)))
               (> ptxy (min px1y px2y))
               (< ptxy (max px1y px2y))
               );and
              (and
               (< ptxx (min px1x px2x))
               (> angpx4 angp4)
               (<= angpx4 (* pi 1.5))
               (< angpx1 angp1)
               (>= angpx1 (* pi 0.5))
               );and
              (and
               (> ptxx(max px1x px2x))
               (or (and (> angpx2 angp2)(<= angpx2 (* pi 2)))
                   (and (>= angpx2 0.0)(<= angpx2 (* pi 0.5)))
                );or
               (or (and (>= angpx3 (* pi 1.5))(<= angpx3 (* pi 2.0)))
                   (and (> angpx3 0.0)(< angpx3 angp3))
                );or
               );and
           );or
      );and
     (progn
      (setq apt1 (list ptxx pve2y)
            apt2 (list ptxx pve1y)
            dp1 (polar pve2 (angle pve2 apt1) exe)
            dp2 (polar pve1 (angle pve1 apt2) exe)
            dp3 (polar apt1 (angle pve2 apt1) exo)
            dp4 (polar apt2 (angle pve1 apt2) exo)
            at1 (polar apt1 (- (angle apt1 apt2) 0.17) asz)
            at2 (polar apt1 (+ (angle apt1 apt2) 0.17) asz)
            at3 (polar apt2 (- (angle apt2 apt1) 0.17) asz)
            at4 (polar apt2 (+ (angle apt2 apt1) 0.17) asz)
            vlst (list 256 dp1 dp3 dp2 dp4 apt1 apt2 at1 apt1 apt1
                            at2 at2 at1 at3 apt2 apt2 at4 at4 at3)
            mode "ver"
            dmode "ver"
       ):setq
          (if (/= promp "ver")
           (progn (setq promp "ver")
                  (prompt "\nVertical? ")
                  (terpri)
            );progn
           );if
      (dodrag)
      );progn
     );cond vertical
    ((= id 3)
     (cond
          ((= mode "align")
           (if (and (> angal angm)(< angal angp))
            (setq pd2 pal2
                  pd1 pal1)
            (setq pd1 pal2
                  pd2 pal1)
            );if
           );al
          ((= mode "hor")
           (cond 
            ((< ptxx ptmx)
              (if (> px2x px1x)
                   (setq pd1 px2
                         pd2 px1
                    );setq
                   (setq pd1 px1
                         pd2 px2
                    );setq
               );if
             )
            ((> ptxx ptmx)
              (if (> px2x px1x)
                   (setq pd1 px1
                         pd2 px2
                    );setq
                   (setq pd1 px2
                         pd2 px1
                    );setq
               );if
             )
            );cond
           );hor
          ((= mode "ver")
           (cond 
            ((< ptxy ptmy)
              (if (> px2y px1y)
                   (setq pd1 px2
                         pd2 px1
                    );setq
                   (setq pd1 px1
                         pd2 px2
                    );setq
               );if
             )
            ((> ptxy ptmy)
              (if (> px2y px1y)
                   (setq pd1 px1
                         pd2 px2
                    );setq
                   (setq pd1 px2
                         pd2 px1
                    );setq
               );if
             )
            );cond
           );ver
    );cond
     (while mode
      (progn (erdrag)
             (command mode pd1 pd2)
             (setq EZkwd2 nil
                   mode nil)
       );progn
      );while
     (setq EZkwd1 nil)
     (ezreset)
     );cond id3
    );cond overall
 );while EZkwd2
);while EZkwd1
  (princ)
);defun 

;;;dodrag determines whether drag needs to be called and sets 
;;;the erasable variables (which begin with er) needed for the
;;;draw-erase cycle to take place.
   (defun dodrag (/ fuz)
    (setq fuz (* 0.001 (getvar "dimscale")))
    (if (not (equal vlst ervlst fuz))
     (erdrag)
     );if
    (if (and vlst drg)
         (progn (drag)
                (setq ervlst vlst
                      vlst nil
                 );setq
          );progn
     );if
    );defun

;;;drag temporarily draws the draglines, leader point
;;;and the box defining the text's boundaries
     (defun drag ()
      (grvecs vlst)
      (setq drg nil
       );setq
      );defun

;;;erdrag erases the draglines and the rest.
     (defun erdrag ()
      (grvecs ervlst)
      (setq drg T
            ervlst nil
       );setq
     );defun
(defun C:ed ()
(ezdim)
);defun
(princ "\n***  EASY DIM loaded!  ***")
(princ "\n    Command name: ED")
(princ)
