;;; UTOOLCFG.lsp
;;;
;;; Boilerplate:
;;;
;;; This is the configuration program for the UTOOLS package.
;;;
;;; As of this release, you can decide of a few features affecting
;;; ElipsTAG and DESCription only.
;;;
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774
;;;
;;;
(defun cferr (cfmsg)
 (if(member cfmsg '("console break" "Function cancelled" "cancel"))
    (princ "\n*User ")
   (princ (strcat "\nError: " cfmsg))
  );if
 (cfrset)
 (princ)
 );defun

;;; Reset functions
(defun cfrset()
 (setq *error* def_err
       cflist nil)
 );defun

;;; Main
(defun utcfg(/ def_err pnam fnam tstr promp prmstr shift lastr colint colist
                colstr lock gscl ascl txstr cflist ofil tmp)
 (setq def_err *error*
       *error* cferr
       fnam "utools.cfg"
       pnam "utoolcfg.lsp"
  );setq
 (if(findfile fnam)
      (progn(setq ofil(open(findfile fnam)"r")
                   tmp T
              );setq
             (while tmp(setq tmp(read-line ofil))
                        (if tmp(setq cflist(cons tmp cflist)))
              );while
              (close ofil)
              (setq cflist(reverse cflist))
       );progn
      (setq cflist(list "a Shifted" "b UTOOL$" "c 5" "d Yes" "e 1.0" "f 1.0"
                        "g UTOOL$"))
  );if
 (setq tstr T)
 (while tstr
  (initget "All Typed Shifted")
  (setq promp(strcat "\nUppercase text: All, Typed, Shifted? <"(substr(nth 0 cflist) 3)">:")
        shift(getkword promp))
  (cond
   ((not shift)(progn (setq shift(nth 0 cflist)tstr nil)))
   ((or(= shift "All")(= shift "Typed")(= shift "Shifted"))
     (setq tstr nil
           cflist(subst(strcat "a " shift)(nth 0 cflist)cflist)))
   );cond
  );while
 (setq tstr T)
 (while tstr
  (setq promp(strcat "\nEnter Layer name for UTOOLS's use <"(strcat(strcase(substr(nth 1 cflist)3 1))(substr(nth 1 cflist)4))">:")
        lastr(getstring promp))
  (if(= lastr "")(setq lastr(substr(nth 1 cflist)3)))
  (if(/= REAL(type(read lastr)))
       (setq tstr nil
             cflist(subst(strcat "b " lastr)(nth 1 cflist)cflist))
       (princ "\n* Invalid layer name. Try again! *")
  );if
  );while
 (setq colint 0
       colist(list "" "Red" "Yellow" "Green" "Cyan" "Blue" "Magenta" "White")
  );setq
 (while(not prmstr)
  (cond
   ((=(substr(nth 2 cflist)3)(itoa(setq colint(1+ colint))))
     (setq prmstr(nth colint colist))
   );cond1
   ((>(atoi(substr(nth 2 cflist) 3))7)
    (setq prmstr(substr(nth 2 cflist) 3))
    );cond2
   );cond ovral
  );while
 (setq tstr T)
 (while tstr
  (initget 129 "Red Yellow Green Cyan Blue Magenta White")
  (setq promp(strcat "\nEnter Color for UTOOLS's use <"prmstr">:")
        colstr(getkword promp))
  (if(= colstr "")(setq colstr(substr(nth 2 cflist)3)))
  (cond
   ((= 'INT(type(read colstr)))
     (setq tstr nil)
    );cond
   ((= colstr "Red")
     (setq colstr "1"
           tstr nil)
    );cond
   ((= colstr "Yellow")
     (setq colstr "2"
           tstr nil)
    );cond
   ((= colstr "Green")
     (setq colstr "3"
           tstr nil)
    );cond
   ((= colstr "Cyan")
     (setq colstr "4"
           tstr nil)
    );cond
   ((= colstr "Blue")
     (setq colstr "5"
           tstr nil)
    );cond
   ((= colstr "Magenta")
     (setq colstr "6"
           tstr nil)
    );cond
   ((= colstr "White")
     (setq colstr "7"
           tstr nil)
    );cond
   );cond ovral
  (if tstr(princ "\n* Invalid color. Try again! *")
          (setq cflist(subst(strcat "c " colstr)(nth 2 cflist)cflist)))
  );while
 (initget "Yes No")
 (setq promp(strcat "\nUTOOLS on a locked layer. Yes or No? <"(substr(nth 3 cflist) 3)">: ")
       lock(getkword promp)
  );setq
 (if lock(setq cflist(subst(strcat "d " lock)(nth 3 cflist)cflist)))
 (initget 2)
 (setq promp(strcat "\nGeneral scale factor for UTOOLS <"(substr(nth 4 cflist) 3)">: ")
       gscl(getreal promp)
  );setq
 (if gscl(setq cflist(subst(strcat "e " (rtos gscl))(nth 4 cflist)cflist)))
 (initget 2)
 (setq promp(strcat "\nArrows scale factor for ElipsTAG <"(substr(nth 5 cflist) 3)">: ")
       ascl(getreal promp)
  );setq
 (if ascl(setq cflist(subst(strcat "f " (rtos ascl))(nth 5 cflist)cflist)))
 (setq tstr T)
 (while tstr
  (setq promp(strcat "\nEnter Textstyle name for UTOOLS's use <"(strcat(strcase(substr(nth 6 cflist)3 1))(substr(nth 6 cflist)4))">:")
        txstr(getstring promp))
  (if(= txstr "")(setq txstr(substr(nth 1 cflist)3)))
  (if(/= REAL(type(read txstr)))
       (setq tstr nil
             cflist(subst(strcat "b " txstr)(nth 6 cflist)cflist))
       (princ "\n* Invalid layer name. Try again! *")
  );if
  );while
 (cond
  ((findfile fnam)
   (progn
    (setq ofil(open(findfile fnam)"w"))
    (foreach it cflist(write-line it ofil))
    (close ofil)
    );progn
   );cond1
  ((findfile pnam)
    (progn
     (setq ofil(open(strcat(substr(findfile pnam)1 
     (-(strlen(findfile pnam))7))"s.cfg")"w"))
     (foreach it cflist(write-line it ofil))
     (close ofil)
     );progn
   );cond2
  ((and(not(findfile fnam))(not(findfile pnam)))
    (princ "\n !!! WARNING !!!  Cannot write configuration file. See manual")
   );cond3
  );cond
 (cfrset)
 (princ)
 );defun

(defun c:utoolcfg()
(utcfg))

(princ "\n*****  Welcome to UTOOLS 1.6 configuration  *****")
(princ "\n         *** ***  C:UTOOLCFG  *** ***")
(princ)
